Unit KbWatch;

interface

uses Crt, Dos;

procedure KbInit;
procedure KbClose;
function KbIsPressed( ch:BYTE ):BOOLEAN;
function KbGetNextKey:BYTE;
procedure KbFree;

var KbDisabled:BOOLEAN;

implementation

var
  KbdIntVec : Procedure;
var Pressed:array[0..128] of BOOLEAN;

procedure Key; interrupt;
var ch:BYTE;
begin
  ch := port[$60];
  if ch < $80 then
  begin
      Pressed[ch] := TRUE;
  end
  else
  begin
      Pressed[ch-$80] := FALSE;
  end;

  inline ($9C); { PUSHF -- Push flags }
  { Call old ISR using saved vector }
  KbdIntVec;
end;
{$F-}

procedure KbInit;
begin
  GetIntVec($9,@KbdIntVec);
  SetIntVec($9,Addr(Key));
end;

procedure KbClose;
begin
  SetIntVec($9,Addr(KbdIntVec));
end;

function KbIsPressed( ch:BYTE ):BOOLEAN;
begin
  KbIsPressed := Pressed[ch];
  if KbDisabled and (ch <> 58) then
     KbIsPressed := FALSE;
end;

function KbGetNextKey:BYTE;
label WaitRelease;
var i:integer;
begin
     while TRUE do begin
         for i := 0 to 127 do begin
             if Pressed[i] then
             begin
                KbGetNextKey := i;
                goto WaitRelease;
             end;
         end;
     end;
WaitRelease:
     while Pressed[i] do ;
end;

procedure KbFree;
begin
    while keypressed do readkey;
end;

{$F+}


begin
end.




