unit Move;

interface

Uses
    Types,uSprite,Setting,crt,KbWatch,Outplay,Graph,uSound;

procedure MoveWorld( var Match:typeMATCH_STATE);
procedure TestHits( var Match:typeMATCH_STATE; var Actions:typeALL_ACTIONS );
procedure TestHitsAlgerian(var Match:typeMATCH_STATE; var Actions:typeALL_ACTIONS );
procedure TestFootFault( i:integer; var Player:typePLAYER_STATE; var Action:typeACTION; var Match:typeMATCH_STATE);
procedure ApplyAction( var Player:typePLAYER_STATE; var Action:typeACTION);
procedure Step( var Match:typeMATCH_STATE );
procedure TransformActionForPlayer(i:integer; var Action:typeACTION);
procedure CopyStateForPlayer(i:integer; var Match,TmpMatch:typeMATCH_STATE);
procedure Rotate( var x:real; var y:real);
procedure RotateVel( var x:real; var y:real);
procedure Go( x,y:real; var Player:typePLAYER_STATE; var Action:typeACTION );
procedure RoleAction( var Player:typePLAYER_STATE; var Action:typeACTION);

implementation

{ Index of bad point for the guy i }
function BadPoint( i:integer ):integer;
begin
    if (i = 1) or (i = 2) then
        BadPoint := 2
    else
        BadPoint := 1;
end;

{ Index of good point for the guy i }
function GoodPoint( i:integer ):integer;
begin
    if (i = 1) or (i = 2) then
        GoodPoint := 1
    else
        GoodPoint := 2;
end;

{function Inside(x,y,x1,y1,x2,y2:real):BOOLEAN;
begin
end;}

{ Keyboard reaction }
procedure KbdTest( var Match:typeMATCH_STATE);
begin
     {Test Keyboard}
     if (KbIsPressed(15)) then          { TAB for 2 player game }
     begin
         Match.bTwoPlayers := not Match.bTwoPlayers;
         while KbIsPressed(15) do;
     end;
     if (KbIsPressed(67)) then          { F9 dec nise limit }
     begin
          dec(Settings.MaximumNoise);
         while KbIsPressed(67) do;
     end;
     if (KbIsPressed(66)) then          { F8++ }
     begin
          Settings.bBeQuite := not Settings.bBeQuite;
         while KbIsPressed(66) do;
     end;
     if (KbIsPressed(68)) then          { F10 inc nise limit }
     begin
          inc(Settings.MaximumNoise);
         while KbIsPressed(68) do;
     end;
     if (KbIsPressed(62)) then          { F4 for fastest mode }
     begin
         Settings.TimeMultiplier := -1*Settings.TimeMultiplier;
         while KbIsPressed(62) do;
     end;
     if (KbIsPressed(58)) then          { CAPS to disable keyboard }
     begin
         KbDisabled := not KbDisabled;
         while KbIsPressed(58) do;
     end;
     if (KbIsPressed(59)) then          { F1 for redraw            }
     begin
        DrawWorld(REDRAW_ALL,Match);
     end;
     if (KbIsPressed(1)) then           { ESC for escape match     }
     begin
         Match.bStopMatch := TRUE;
         Settings.SecWaitAfterGame := Settings.SecWaitAfterGame / 2;
         Settings.SecWaitAfterSet := Settings.SecWaitAfterSet / 2;
         Settings.WaitAfterScored := Settings.WaitAfterScored / 2;
         while KbIsPressed(1) do;
     end;
     if (KbIsPressed(78)) then          { + to speed up }
     begin
         Settings.TimeStep := Settings.TimeStep*1.2;
         while KbIsPressed(78) do;
     end;
     if (KbIsPressed(74)) then          { - to speed down }
     begin
         Settings.TimeStep := Settings.TimeStep/1.2;
         while KbIsPressed(74) do;
     end;
     if (KbIsPressed(63)) then          { - to end the current point }
     begin
         with Match do begin
             JudgeSad := JUDGE_LOST;
             Event := EVENT_SCORED;
             EventWho := 0;
             Match.LastPointTo := BadPoint(iServer);
             WhereBall := WHEREBALL_OUT_OF_GAME;
         end;
         while KbIsPressed(63) do;
     end;
end;

var lastDrawTime:longint;

{ Move the worl one time step }
procedure MoveWorld( var Match:typeMATCH_STATE);
var
   ArchiveFile:text;
   timeBefore:longint;
   timeAfter:longint;
   Actions:typeALL_ACTIONS;
   i:integer;
   TmpMatch:typeMATCH_STATE;
   WaitTime:real;
begin

     KbdTest(Match);


     { For all players }
     for i := 1 to 4 do begin
         if (Match.bTwoPlayers) and ((i = 2) or (i = 4)) then
         begin
            if (Match.iServer = 2) then Match.iServer := 1;
            if (Match.iServer = 4) then Match.iServer := 3;
            continue;
         end;
         { Create a copy of the state of things for the player i }
         CopyStateForPlayer(i,Match,TmpMatch);
         Actions[i].HandHold := HAND_STAND_BY;
         Actions[i].VelocityX := 0;
         Actions[i].VelocityY := 0;
         Actions[i].AimX := 0;
         Actions[i].AimY := 0;
         Actions[i].MessageLong := 0;
         Actions[i].MessageX := 0;
         Actions[i].MessageY := 0;
         Actions[i].MessageString := 'Nothing';

         { Get His action }
         timeBefore := GetExactTime;
         Settings.Players[Match.Players[i].PlayerNo].FnCompute(TmpMatch,Actions[i]);
         timeAfter := GetExactTime;

         Actions[i].AimX := Settings.GroundAxisX;
         Actions[i].AimY := Settings.NetY;

         Match.Players[i].LastComputeDuration := (timeAfter - timeBefore)*EXACT_TIME_STEP;

         if (Match.Players[i].LastComputeDuration > Settings.MaxComputeDuration) then
         begin
             inc(Match.Players[i].TimePenaltyPoints);
             if Settings.bTestTime and (Match.Players[i].TimePenaltyPoints > Settings.MaxPenaltyPoints) then
             begin
                 { Disqualify -- to many time penalty points }
                 with Settings.Players[Match.Players[i].PlayerNo] do begin
                     Color := 8;
                     FnGetName := Outplay.GetName;
                     FnInitSession := Outplay.InitSession;
                     FnInitMatch := OutPlay.InitMatch;
                     FnCompute := Outplay.Compute;
                 end;
             end;
         end;

         if (TmpMatch.Players[1].bFreeWill = FALSE) then
         begin
             RoleAction(TmpMatch.Players[1],Actions[i]); { the default }
         end;


         { Transform action back }
         TransformActionForPlayer(i,Actions[i]);
     end;

     { 2 player game -- some modifications ---- not interesting }
     if (Match.bTwoPlayers) then
     begin
         Match.Players[2].Role := ROLE_WAIT;
         RoleAction(Match.Players[2],Actions[2]);
         Match.Players[4].Role := ROLE_WAIT;
         RoleAction(Match.Players[4],Actions[4]);
         for i := 1 to 4 do if (Match.Players[i].Role = ROLE_PRE_NET_PLAYER) then
            begin
                Match.Players[i].Role := ROLE_PRE_RETURN;
                Match.Players[i].Position := 1 - Match.Players[i].Position;
            end;
     end;

     Match.Event := EVENT_NONE;
     Match.EventWho := 0;

     { Foot faults }
     for i := 1 to 4 do begin
         if (Match.bTwoPlayers) and ((i = 2) or (i = 4)) then
         begin
            if (Match.iServer = 2) then Match.iServer := 1;
            if (Match.iServer = 4) then Match.iServer := 3;
            continue;
         end;
         { Create a copy of the state of things for the player i }
         CopyStateForPlayer(i,Match,TmpMatch);
         { Test foot faults }
         TestFootFault(i,TmpMatch.Players[1],Actions[i],Match);
     end;

     { Apply all actions }
     for i := 1 to 4 do begin
         ApplyAction(Match.Players[i],Actions[i]);
     end;

     { Syncronize }
     if (Settings.TimeMultiplier > 0) and ((GetExactTime - lastDrawTime)*EXACT_TIME_STEP*Settings.TimeMultiplier <
                                           Settings.TimeStep*Settings.nStepsPerCount) then
     begin
          WaitTime := Settings.TimeStep*Settings.nStepsPerCount/Settings.TimeMultiplier -
             (GetExactTime - lastDrawTime)*EXACT_TIME_STEP;
          while (GetExactTime - lastDrawTime)*EXACT_TIME_STEP*Settings.TimeMultiplier
                             < Settings.TimeStep*Settings.nStepsPerCount do
          begin
              {Idle}
          end;
     end
     else
        WaitTime := 0;
     if Settings.bDisplayIdle then
     begin


{    assign(ArchiveFile,Settings.strScoreFile);
    append(ArchiveFile);
    writeln(ArchiveFile,WaitTime);
    close(ArchiveFile);}


        i := trunc(WaitTime/(Settings.TimeStep*Settings.nStepsPerCount/Settings.TimeMultiplier)*639);
        setcolor(1);
        MoveTo(0,460);
        LineTo(i,460);
        setcolor(0);
        MoveTo(i+1,460);
        LineTo(639,460);
     end;
     lastDrawTime := GetExactTime;

     if not Settings.bSmoothRedraw then
         DrawWorld(REDRAW_GAME,Match);


     for i := 1 to Settings.nStepsPerCount do begin

        if Settings.bSmoothRedraw then
            DrawWorld(REDRAW_GAME,Match);

        { Test line, net hits }
        TestHitsAlgerian(Match,Actions);

        Step(Match);

        { Test player hits }
        TestHits(Match,Actions);
     end;

     soundEvent(Match.Event,Match.EventWho,Match.JudgeSad);

end;

{ Player hits }
procedure TestHits( var Match:typeMATCH_STATE; var Actions:typeALL_ACTIONS );
var i,iServer:integer;
begin
    iServer := Match.iServer;
    if (Match.WhereBall = WHEREBALL_SERVER_HAS) then
    begin
       if (Match.Players[iServer].HandHold = HAND_SERVICE) and (Match.Players[iServer].Role = ROLE_SERVICE) then
       begin
          { Service }
          if (iServer = 1) or (iServer = 2) then
              Match.WhereBall := WHEREBALL_YOU_SERVER_HIT
          else
              Match.WhereBall := WHEREBALL_ENEMY_SERVER_HIT;
          Match.Event := EVENT_HIT_BALL;
          Match.EventWho := iServer;
          Match.Players[iServer].Role := ROLE_BACK_PLAYER;

          for i := 1 to 4 do
              if Match.Players[i].Role = ROLE_RETURN then
                  Match.Players[i].Role := ROLE_BACK_PLAYER;

          {Service}
          Match.BallX := Match.Players[iServer].PositionX;
          Match.BallY := Match.Players[iServer].PositionY;
          Match.BallZ := 2.5;
          Match.BallVX := Actions[iServer].AimX - Match.Players[iServer].PositionX;
          Match.BallVY := Actions[iServer].AimY - Match.Players[iServer].PositionY;
          Match.BallVZ := 0;
          VectInDir(Match.BallVX,Match.BallVY,Settings.Players[Match.Players[iServer].PlayerNo].ServiceSpeed);
       end
       else
       begin
          Match.BallX := Match.Players[iServer].PositionX;
          Match.BallY := Match.Players[iServer].PositionY;
          Match.BallZ := 1.2;
          Match.BallVX := Match.Players[iServer].VelocityX;
          Match.BallVY := Match.Players[iServer].VelocityY;
          Match.BallVZ := 0;
       end;
    end;
    for i := 1 to 2 do begin
        if (Match.WhereBall = WHEREBALL_ENEMY_HIT) or (Match.WhereBall = WHEREBALL_ENEMY_SERVER_HIT) then
        begin
            if Distance(Match.Players[i].PositionX,Match.Players[i].PositionY,Match.BallX,Match.BallY) <
                     Settings.Players[Match.Players[i].PlayerNo].Radius then
               begin
                   {Hit player}
                   Match.BallVX := Match.BallX - Match.Players[i].PositionX;
                   Match.BallVY := Match.BallY - Match.Players[i].PositionY;
                   Match.BallVZ := 0;
                   VectInDir(Match.BallVX,Match.BallVY,Settings.Players[Match.Players[i].PlayerNo].ReturnSpeed);
                   Match.WhereBall := WHEREBALL_YOU_HIT;
                   Match.Event := EVENT_HIT_BALL;
                   Match.EventWho := i;
               end;
        end;
    end;
    for i := 3 to 4 do begin
        if (Match.WhereBall = WHEREBALL_YOU_HIT) or (Match.WhereBall = WHEREBALL_YOU_SERVER_HIT) then
        begin
            if Distance(Match.Players[i].PositionX,Match.Players[i].PositionY,Match.BallX,Match.BallY) <
                      Settings.Players[Match.Players[i].PlayerNo].Radius then
               begin
                   {Hit player}
                   Match.BallVX := Match.BallX - Match.Players[i].PositionX;
                   Match.BallVY := Match.BallY - Match.Players[i].PositionY;
                   Match.BallVZ := 0;
                   VectInDir(Match.BallVX,Match.BallVY,Settings.Players[Match.Players[i].PlayerNo].ReturnSpeed);
                   Match.WhereBall := WHEREBALL_ENEMY_HIT;
                   Match.Event := EVENT_HIT_BALL;
                   Match.EventWho := i;
               end;
        end;
    end;

end;

function HitX( x1,x2,y:real; var Match:typeMATCH_STATE ):BOOLEAN;
begin
  HitX := FALSE;
  if (Match.BallY-y)*(Match.BallY+Settings.TimeStep*Match.BallVY-y) <= 0 then
  begin
     if (Match.BallX-x1)*(Match.BallX-x2) <= 0 then
         HitX := TRUE;
     if (Match.BallX+Settings.TimeStep*Match.BallVX-x1)*(Match.BallX+Settings.TimeStep*Match.BallVX-x2) <= 0 then
         HitX := TRUE;
  end;
end;

function HitY( y1,y2,x:real; var Match:typeMATCH_STATE ):BOOLEAN;
begin
  HitY := FALSE;
  if (Match.BallX-x)*(Match.BallX+Settings.TimeStep*Match.BallVX-x) <= 0 then
  begin
     if (Match.BallY-y1)*(Match.BallY-y2) <= 0 then
         HitY := TRUE;
     if (Match.BallY+Settings.TimeStep*Match.BallVY-y1)*(Match.BallY+Settings.TimeStep*Match.BallVY-y2) <= 0 then
         HitY := TRUE;
  end;
end;

{ Line hits }
procedure TestHitsAlgerian(var Match:typeMATCH_STATE; var Actions:typeALL_ACTIONS );
begin
    if (Match.WhereBall = WHEREBALL_YOU_HIT) or (Match.WhereBall = WHEREBALL_YOU_SERVER_HIT) then
    begin
       if   HitX(Settings.AlgerianX1,Settings.AlgerianX2,Settings.AlgerianY2,Match) or
            HitY(Settings.NetY,Settings.AlgerianY2,Settings.AlgerianX1,Match) or
            HitY(Settings.NetY,Settings.AlgerianY2,Settings.AlgerianX2,Match) then
        begin
          {You've scored}
          with Match do begin
              JudgeSad := JUDGE_LOST;
              Event := EVENT_SCORED;
              LastPointTo := 1;
              WhereBall := WHEREBALL_OUT_OF_GAME;
          end;
        end;
       if   HitY(Settings.NetY,Settings.NetY+Settings.AlgerianD,Settings.GroundX1,Match) or
            HitY(Settings.NetY,Settings.NetY+Settings.AlgerianD,Settings.GroundX2,Match) or
            {service}
            ((Match.WhereBall = WHEREBALL_YOU_SERVER_HIT) and (Match.Players[Match.iServer].Position = SIDE_RIGHT)
            and HitX(Settings.GroundAxisX,Settings.GroundX2,Settings.NetY+Settings.AlgerianD,Match)) or
            ((Match.WhereBall = WHEREBALL_YOU_SERVER_HIT) and (Match.Players[Match.iServer].Position = SIDE_LEFT)
            and HitX(Settings.GroundAxisX,Settings.GroundX1,Settings.NetY+Settings.AlgerianD,Match)) then
        begin
          {You've hit the net}
          with Match do begin
              JudgeSad := JUDGE_NET;
              Event := EVENT_SCORED;
              LastPointTo := 2;
              WhereBall := WHEREBALL_OUT_OF_GAME;
          end;
        end;
       if   HitX(Settings.AlgerianX1,Settings.AlgerianX2,Settings.AlgerianY1,Match) or
            HitY(Settings.NetY,Settings.AlgerianY1,Settings.AlgerianX1,Match) or
            HitY(Settings.NetY,Settings.AlgerianY1,Settings.AlgerianX2,Match) or
            HitX(Settings.AlgerianX1,Settings.GroundX1,Settings.NetY,Match) or
            HitX(Settings.AlgerianX2,Settings.GroundX2,Settings.NetY,Match) then
        begin
          {Out of the playground}
          with Match do begin
              JudgeSad := JUDGE_OUT;
              Event := EVENT_SCORED;
              LastPointTo := 2;
              WhereBall := WHEREBALL_OUT_OF_GAME;
          end;
        end;
    end;

    if (Match.WhereBall = WHEREBALL_ENEMY_HIT) or (Match.WhereBall = WHEREBALL_ENEMY_SERVER_HIT) then
    begin
       if   HitX(Settings.AlgerianX1,Settings.AlgerianX2,Settings.AlgerianY1,Match) or
            HitY(Settings.NetY,Settings.AlgerianY1,Settings.AlgerianX1,Match) or
            HitY(Settings.NetY,Settings.AlgerianY1,Settings.AlgerianX2,Match) then
        begin
          {You've scored}
          with Match do begin
              JudgeSad := JUDGE_LOST;
              Event := EVENT_SCORED;
              LastPointTo := 2;
              WhereBall := WHEREBALL_OUT_OF_GAME;
          end;
        end;
       if   HitY(Settings.NetY,Settings.NetY-Settings.AlgerianD,Settings.GroundX1,Match) or
            HitY(Settings.NetY,Settings.NetY-Settings.AlgerianD,Settings.GroundX2,Match) or
            {service}
            ((Match.WhereBall = WHEREBALL_ENEMY_SERVER_HIT) and (Match.Players[Match.iServer].Position = SIDE_RIGHT)
            and HitX(Settings.GroundAxisX,Settings.GroundX2,Settings.NetY-Settings.AlgerianD,Match)) or
            ((Match.WhereBall = WHEREBALL_ENEMY_SERVER_HIT) and (Match.Players[Match.iServer].Position = SIDE_LEFT)
            and HitX(Settings.GroundAxisX,Settings.GroundX1,Settings.NetY-Settings.AlgerianD,Match)) then
        begin
          {You've hit the net}
          with Match do begin
              JudgeSad := JUDGE_NET;
              Event := EVENT_SCORED;
              LastPointTo := 1;
              WhereBall := WHEREBALL_OUT_OF_GAME;
          end;
        end;
       if   HitX(Settings.AlgerianX1,Settings.AlgerianX2,Settings.AlgerianY2,Match) or
            HitY(Settings.NetY,Settings.AlgerianY2,Settings.AlgerianX1,Match) or
            HitY(Settings.NetY,Settings.AlgerianY2,Settings.AlgerianX2,Match) or
            HitX(Settings.AlgerianX1,Settings.GroundX1,Settings.NetY,Match) or
            HitX(Settings.AlgerianX2,Settings.GroundX2,Settings.NetY,Match) then
        begin
          {Out of the playground}
          with Match do begin
              JudgeSad := JUDGE_OUT;
              Event := EVENT_SCORED;
              LastPointTo := 1;
              WhereBall := WHEREBALL_OUT_OF_GAME;
          end;
        end;
    end;


(*    if (Match.WhereBall = WHEREBALL_YOU_HIT) then
    begin
        if not Inside(Match.BallX,Match.BallY,
              Settings.AlgerianX1,Settings.AlgerianY1,Settings.AlgerianX2,Settings.AlgerianY2) then
        begin
          {You've send the ball out of the playground}
          with Match do begin
              JudgeSad := JUDGE_OUT;
              Event := EVENT_SCORED;
              LastPointTo := 1;
              WhereBall := WHEREBALL_OUT_OF_GAME;
          end;
        if Inside(Match.BallX,Match.BallY,
               Settings.GroundX1,Settings.NetY,Settings.GroundX2,Settings.NetY+Settings.AlgerianD) then
        begin
          {Hit the dest area}
          with Match do begin
              Event := EVENT_BALL_JUMPED;
              WhereBall := WHEREBALL_ENEMY_ONCE_DROPED;
          end;
        end;
    end;*)
end;

procedure TestFootFault( i:integer; var Player:typePLAYER_STATE; var Action:typeACTION; var Match:typeMATCH_STATE );
begin
     if (Match.WhereBall = WHEREBALL_OUT_OF_GAME) then
         exit;

     if (Player.Role = ROLE_SERVICE) and (Action.HandHold = HAND_SERVICE) then
     begin
         if (Player.PositionY > 0) or
            ((Player.Position = SIDE_LEFT) and (Player.PositionX > (Settings.GroundX1+Settings.GroundX2)/2)) or
            ((Player.Position = SIDE_RIGHT) and (Player.PositionX < (Settings.GroundX1+Settings.GroundX2)/2)) then
            with Match do begin
                JudgeSad := JUDGE_SERVICE_FOOT_FAULT;
                Event := EVENT_SCORED;
                LastPointTo := BadPoint(i);
                WhereBall := WHEREBALL_OUT_OF_GAME;
            end;
     end;
     if ((Player.Role = ROLE_NET_PLAYER) or (Player.Role = ROLE_BACK_PLAYER)) and
        (Player.PositionY > Settings.NetY-Settings.AlgerianD) then
        with Match do begin
            JudgeSad := JUDGE_FOOT_FAULT;
            Event := EVENT_SCORED;
            LastPointTo := BadPoint(i);
            WhereBall := WHEREBALL_OUT_OF_GAME;
        end;
end;

procedure ApplyAction( var Player:typePLAYER_STATE; var Action:typeACTION);
begin
     VectMaxInDir(Action.VelocityX,Action.VelocityY,Settings.Players[Player.PlayerNo].MaxSpeed);
     Player.HandHold := Action.HandHold;
     Player.VelocityX := Action.VelocityX;
     Player.VelocityY := Action.VelocityY;

     Player.MessageLong := Action.MessageLong;
     Player.MessageX := Action.MessageX;
     Player.MessageY := Action.MessageY;
     Player.MessageString := Action.MessageString;
end;

procedure Step( var Match:typeMATCH_STATE );
var i:integer;
begin

     for i := 1 to 4 do begin
         Match.Players[i].PositionX := Match.Players[i].PositionX + Match.Players[i].VelocityX*Settings.TimeStep;
         Match.Players[i].PositionY := Match.Players[i].PositionY + Match.Players[i].VelocityY*Settings.TimeStep;
     end;
     Match.BallX := Match.BallX + Match.BallVX*Settings.TimeStep;
     Match.BallY := Match.BallY + Match.BallVY*Settings.TimeStep;

     Match.MatchTime := Match.MatchTime+Settings.TimeStep;
     Match.PointTime := Match.PointTime+Settings.TimeStep;

     {tirednes}
end;

{ THE ROTATION OF THE PLAYGROUND }

procedure TransformActionForPlayer(i:integer; var Action:typeACTION);
begin
     if (i = 3) or (i = 4) then
     begin
         Rotate(Action.AimX,Action.AimY);
         RotateVel(Action.VelocityX,Action.VelocityY);
     end;
end;

procedure CopyStateForPlayer(i:integer; var Match,TmpMatch:typeMATCH_STATE);
var j:integer;

begin
    TmpMatch := Match;
    if i = 1 then begin
    end;
    if i = 2 then begin
       TmpMatch.Players[1] := Match.Players[2];
       TmpMatch.Players[2] := Match.Players[1];
    end;
    if i = 3 then begin
       TmpMatch.Players[1] := Match.Players[3];
       TmpMatch.Players[2] := Match.Players[4];
       TmpMatch.Players[3] := Match.Players[1];
       TmpMatch.Players[4] := Match.Players[2];
       TmpMatch.Score.Points[1] := Match.Score.Points[2];
       TmpMatch.Score.Points[2] := Match.Score.Points[1];
       TmpMatch.Score.Games[1] := Match.Score.Games[2];
       TmpMatch.Score.Games[2] := Match.Score.Games[1];
       TmpMatch.Score.Sets[1] := Match.Score.Sets[2];
       TmpMatch.Score.Sets[2] := Match.Score.Sets[1];
    end;
    if i = 4 then begin
       TmpMatch.Players[1] := Match.Players[4];
       TmpMatch.Players[2] := Match.Players[3];
       TmpMatch.Players[3] := Match.Players[2];
       TmpMatch.Players[4] := Match.Players[1];
       TmpMatch.Score.Points[1] := Match.Score.Points[2];
       TmpMatch.Score.Points[2] := Match.Score.Points[1];
       TmpMatch.Score.Games[1] := Match.Score.Games[2];
       TmpMatch.Score.Games[2] := Match.Score.Games[1];
       TmpMatch.Score.Sets[1] := Match.Score.Sets[2];
       TmpMatch.Score.Sets[2] := Match.Score.Sets[1];
    end;
    if (i = 3) or (i = 4) then
    begin
        if Match.LastPointTo <> 0 then
            TmpMatch.LastPointTo := 3 - Match.LastPointTo;


        if (Match.WhereBall = WHEREBALL_YOU_HIT) then
            TmpMatch.WhereBall := WHEREBALL_ENEMY_HIT;
        if (Match.WhereBall = WHEREBALL_ENEMY_HIT) then
            TmpMatch.WhereBall := WHEREBALL_YOU_HIT;
        if (Match.WhereBall = WHEREBALL_YOU_ONCE_DROPED) then
            TmpMatch.WhereBall := WHEREBALL_ENEMY_ONCE_DROPED;
        if (Match.WhereBall = WHEREBALL_ENEMY_ONCE_DROPED) then
            TmpMatch.WhereBall := WHEREBALL_YOU_ONCE_DROPED;
        if (Match.WhereBall = WHEREBALL_YOU_SERVER_HIT) then
            TmpMatch.WhereBall := WHEREBALL_ENEMY_SERVER_HIT;
        if (Match.WhereBall = WHEREBALL_ENEMY_SERVER_HIT) then
            TmpMatch.WhereBall := WHEREBALL_YOU_SERVER_HIT;

        Rotate(TmpMatch.BallX,TmpMatch.BallY);
        RotateVel(TmpMatch.BallVX,TmpMatch.BallVY);
        for j := 1 to 4 do begin
            Rotate(TmpMatch.Players[j].PositionX,TmpMatch.Players[j].PositionY);
            RotateVel(TmpMatch.Players[j].VelocityX,TmpMatch.Players[j].VelocityY);
            if (TmpMatch.Players[j].Position = SIDE_LEFT) then
                TmpMatch.Players[j].Position := SIDE_RIGHT
            else
                TmpMatch.Players[j].Position := SIDE_LEFT;
        end;
    end;
end;

procedure Rotate( var x:real; var y:real);
begin
    x := Settings.GroundX1+Settings.GroundX2 - x;
    y := Settings.GroundY1+Settings.GroundY2 - y;
end;

procedure RotateVel( var x:real; var y:real);
begin
     x := -x;
     y := -y;
end;

{ AUTOMATIC ROLE FUNCTIONS }

procedure Go( x,y:real; var Player:typePLAYER_STATE; var Action:typeACTION );
var MaxAxisSpeed:real;
begin
    Action.VelocityX := (x - Player.PositionX)*15;
    Action.VelocityY := (y - Player.PositionY)*15;

    MaxAxisSpeed := Settings.Players[Player.PlayerNo].NeutralSpeed/1.4;

     if (Action.VelocityX > MaxAxisSpeed) then Action.VelocityX := MaxAxisSpeed;
     if (Action.VelocityY > MaxAxisSpeed) then Action.VelocityY := MaxAxisSpeed;
     if (Action.VelocityX < -MaxAxisSpeed) then Action.VelocityX := -MaxAxisSpeed;
     if (Action.VelocityY < -MaxAxisSpeed) then Action.VelocityY := -MaxAxisSpeed;
end;

{ Default actions implementation }
procedure RoleAction( var Player:typePLAYER_STATE; var Action:typeACTION);
var x,y:real;
begin
    case Player.Role of
ROLE_WAIT:
          begin
               Action.HandHold := HAND_STAND_BY;
               Action.VelocityX := 0;
               Action.VelocityY := 0;
               Go(-1,(Settings.GroundY1+Settings.GroundY2)/2 + 2*Player.PlayerNo-3,Player,Action);
          end;
ROLE_PRE_SERVICE:
          begin
               Action.HandHold := HAND_STAND_BY;
               x := (Settings.GroundX1 + Settings.GroundX2)/2;
               if (Player.Position = SIDE_LEFT) then
                   x := x - 1
               else
                  x := x + 1;
               y := Settings.GroundY1-0.3;
               Go(x,y,Player,Action);
          end;
ROLE_PRE_NET_PLAYER:
          begin
               Action.HandHold := HAND_STAND_BY;
               x := (Settings.GroundX1 + Settings.GroundX2)/2;
               if (Player.Position = SIDE_LEFT) then
                   x := (x + Settings.GroundX1)/2
               else
                   x := (x + Settings.GroundX2)/2;
               y := Settings.GroundY1 + Settings.ServiceDY;
               Go(x,y,Player,Action);
          end;
ROLE_PRE_RETURN:
          begin
               Action.HandHold := HAND_STAND_BY;
               x := (Settings.GroundX1 + Settings.GroundX2)/2;
               if (Player.Position = SIDE_LEFT) then
                   x := (x + Settings.GroundX1)/2
               else
                   x := (x + Settings.GroundX2)/2;
               y := Settings.GroundY1 - 0.7;
               Go(x,y,Player,Action);
          end;
ROLE_SERVICE:
          begin
               Action.HandHold := HAND_SERVICE;
               Action.VelocityX := 0;
               Action.VelocityY := 0;
               Action.AimX := Settings.GroundAxisX;
               Action.AimY := Settings.NetY;
          end;
ROLE_RETURN:
          begin
               Action.HandHold := HAND_FOREHAND;
               Action.VelocityX := 0;
               Action.VelocityY := 0;
          end;
ROLE_NET_PLAYER:
          begin
               Action.HandHold := HAND_FOREHAND;
               Action.VelocityX := 0;
               Action.VelocityY := 0;
          end;
ROLE_BACK_PLAYER:
          begin
               Action.HandHold := HAND_FOREHAND;
               Action.VelocityX := 0;
               Action.VelocityY := 0;
          end;
    end;
end;


begin
    lastDrawTime := 0;
end.