Unit Outplay;

interface

   uses Types,crt;

   { The functions called by the environment }
   function GetName:string;
   function InitSession( iPlayer:integer ):string;
   function InitMatch(var Match:typeMATCH_STATE):string;
   procedure Compute(var Match:typeMATCH_STATE; var Action:typeACTION);

implementation

{ GetName - function called by the environment to learn the players name
}
function GetName:string;
begin
    GetName := 'Disqualified';
end;

{ InitSession - function called by the environment to let the player
        initialize it's internal structures. This function is called only
        once per a tournament.

  Return Value: is ignored.
}
function InitSession( iPlayer:integer ):string;
begin
     InitSession := 'CHODTE DO KELU';
end;

{ InitMatch - called by the environment to let the player initialize it's
         internal structures before each match.

  Parameters: Match - a structure containing match information
  Return Value: is ignored
}
function InitMatch( var Match:typeMATCH_STATE ):string;
begin
     InitMatch := 'PAZA';
end;

{ Compute - called by the environment to get the step's action from the
        player. The duration of this procedure should not be more then
        Settings.MaxComputeDuration.

  Parameters: Match - information about the match: player positions etc.
                      You are alwais the player[1] in the Match structure.
                      Match.Players[1].bFreeWill is set to TRUE -- the
                      action returned is ignored and a default substitution
                      is done (look: move.pas, procedure RoleAction).
              Action - the action to be preformed
}
procedure Compute( var Match:typeMATCH_STATE; var Action:typeACTION);
var
    me:^typePLAYER_STATE;
begin
    { The disqualified player }

    me := @(Match.Players[1]); { Players[1] - that's me                     }
                               { Players[2] - that's my friend              }
                               { Players[3], Player[4] - that are my enemies}

    if (me^.Role = ROLE_PRE_SERVICE) or (me^.Role = ROLE_SERVICE) then
        me^.bFreeWill := FALSE
    else
    begin
        me^.bFreeWill := TRUE;
        Action.VelocityX := ((-2)-me^.PositionX)*4;
        Action.VelocityY := (0-me^.PositionY)*4;
    end;
end;

end.