{ computer settings }
Unit Setting;

interface

Uses Types,player1,player2,player3,player4,player5,Intro,wtplay;

procedure InitSettings;


implementation

procedure InitSettings;
var i:integer;
begin
    with Settings do begin
        GroundX1 := 0;              { The position of the PlayGround         }
        GroundY1 := 0;
        GroundX2 := 10.97244;
        GroundY2 := 23.77362;
        ServiceDX := 1.371555;      { The position of the bounderies for     }
        ServiceDY := 5.48622;       { service                                }
                                    { Ackerman's bounderies                  }
        AlgerianX1 := GroundX1 - 2.43832;
        AlgerianY1 := GroundY1 - 2.43832;
        AlgerianX2 := GroundX2 + 2.43832;
        AlgerianY2 := GroundY2 + 2.43832;
        AlgerianD := 2.43832;       { Yellow line distance from the net      }

        AlgerianBallSpeed := 20;    { Default ball speed                     }
        AlgerianServiceBallSpeed := 32;{ Default service ball speed             }
        AlgerianMaxPlayerSpeed := 20/4;{ Default maximum player speed           }
        AlgerianNeutralSpeed := 20/4;{ Default neutral player speed           }
        AlgerianPlayerRadius := 0.5;  { Default player radius                  }

        NetY := (GroundY1 + GroundY2) / 2;
        GroundAxisX := (GroundX1 + GroundX2) / 2;

        nPlayers := 5;              { Number of players in the tournament    }
        nMatches := 2;              { Number of matches                      }
        nPointsToWinGame := 4;
        nGamesToWinSet := 6;
        nSetsToWinMatch := 2;
        maxPoints := 10;
        maxGames := 10;
        GameMode := GAME_TOURNAMENT;
        DisplayMode := DISPLAY_2D;
        bWaitRetrace := FALSE;
        bDebugOutput := FALSE;

        TimeStep := 0.005;
        TimeMultiplier := 1;      { set to -1 for fastest mode }
        nStepsPerCount := 5;

        MaxPenaltyPoints := 10;
        MaxComputeDuration := 0.01;
        bTestTime := TRUE;
        bDisplayIdle := FALSE;
        bSmoothRedraw := FALSE;
        bProcessorTestPlayers := FALSE;

        bSound := TRUE;
        bGus := FALSE;
        bBeQuite := TRUE;
        TimeToBeQuite := 4;
        MinTimeToRepeatBeQuite := 5;
        MaximumNoise := 1;

        SecWaitBeforeBegin := 10;
        SecDelayBegin := 0.1;
        SecToServe := 10;
        maxVtoBegin := 0.2;
        SecWaitAfterGame := 6;
        SecWaitAfterSet := 10;
        WaitAfterScored := 1;

        bIntro := TRUE;
        bRecordGame := FALSE;
        strRecordFile := 'rec.dat';
        strScoreFile := 'score.dat';

        ScreenRect.x1 := 0;
        ScreenRect.y1 := 0;
        ScreenRect.x2 := 639;
        ScreenRect.y2 := 479;

        for i := 1 to nPlayers do begin
           Players[i].ServiceSpeed := AlgerianServiceBallSpeed;
           Players[i].ReturnSpeed := AlgerianBallSpeed;
           Players[i].MaxSpeed := AlgerianMaxPlayerSpeed;
           Players[i].NeutralSpeed := AlgerianNeutralSpeed;
           Players[i].Radius := AlgerianPlayerRadius;
        end;
    end;



    with Settings.Players[1] do begin
        Color := 9;
        FnGetName := player1.GetName;
        FnInitSession := player1.InitSession;
        FnInitMatch := player1.InitMatch;
        FnCompute := player1.Compute;
    end;

    with Settings.Players[2] do begin
        Color := 10;
        FnGetName := player2.GetName;
        FnInitSession := player2.InitSession;
        FnInitMatch := player2.InitMatch;
        FnCompute := player2.Compute;
    end;

    with Settings.Players[3] do begin
        Color := 11;
        FnGetName := player3.GetName;
        FnInitSession := player3.InitSession;
        FnInitMatch := player3.InitMatch;
        FnCompute := player3.Compute;
    end;

    with Settings.Players[4] do begin
        Color := 12;
        FnGetName := player4.GetName;
        FnInitSession := player4.InitSession;
        FnInitMatch := player4.InitMatch;
        FnCompute := player4.Compute;
    end;

    with Settings.Players[5] do begin
        Color := 13;
        FnGetName := player5.GetName;
        FnInitSession := player5.InitSession;
        FnInitMatch := player5.InitMatch;
        FnCompute := player5.Compute;
    end;

    if Settings.bProcessorTestPlayers then begin
        with Settings do begin
            for i:= 1 to nPlayers do begin
                Players[i].FnGetName := wtplay.GetName;
                Players[i].FnInitSession := wtplay.InitSession;
                Players[i].FnInitMatch := wtplay.InitMatch;
                Players[i].FnCompute := wtplay.Compute;
            end;
        end;
    end;
    { Let this record allways be the last one}
{    with Settings.Players[5] do begin
        FnGetName := Hovno.GetName;
        FnInitSession := Hovno.InitSession;
        FnInitMatch := Hovno.InitMatch;
        FnCompute := Hovno.Compute;
    end;
 }
    with Settings do begin
        Schedule[1][1] := 1;
        Schedule[1][2] := 2;
        Schedule[1][3] := 3;
        Schedule[1][4] := 4;

        Schedule[2][1] := 2;
        Schedule[2][2] := 5;
        Schedule[2][3] := 1;
        Schedule[2][4] := 3;
    end;

end;

begin
    InitSettings;
end.