Unit Types;

interface

const
    MAX_PLAYERS = 10;
    MAX_MATCHES = 30;
    GAME_TOURNAMENT = 0;
    DISPLAY_2D = 0;
    DISPLAY_PIC = 1;

    EXACT_TIME_STEP = 214.5527079e-6;
    EXACT_TIME_CLICKS_PER_SEC = 4660.859375;

    { Constants defining the last sectence of the judge }
    JUDGE_NOTHING          = 0;         { Nothing interesting to say, yet    }
    JUDGE_OUT              = 1;         { It was a out                       }
    JUDGE_LOST             = 2;         { The ball was not returned          }
    JUDGE_NET              = 3;         { Net                                }
    JUDGE_SERVICE_OUT      = 4;         { !! not used                        }
    JUDGE_SERVICE_NET      = 5;         { !! not used                        }
    JUDGE_SERVICE_FOOT_FAULT = 6;       { Foot fault when serving            }
    JUDGE_SERVICE_TIMEOUT = 7;          { Did not serve in limit             }
    JUDGE_FOOT_FAULT = 8;               { Any foot fault                     }

    { Event constans - what did happen in this step ?}
    EVENT_NONE             = 0;         { No event                           }
    EVENT_HIT_BALL         = 1;         { Some player hit the ball in this   }
                                        { step                               }
    EVENT_JUMPED_BALL      = 2;         { !! not used                        }
    EVENT_SCORED           = 3;         { Someone scored                     }
    EVENT_BEGIN_PLAY       = 4;         { Let's begin                        }


    { HandHold constans }
    HAND_STAND_BY          = 0;         { just standing                      }
    HAND_FOREHAND          = 1;         { !! not used                        }
    HAND_BACKHAND          = 2;         { !! not used                        }
    HAND_SMASH             = 3;         { !! not used                        }
    HAND_STOPBALL          = 4;         { !! not used                        }
    HAND_LOB               = 5;         { !! not used                        }
    HAND_SERVICE           = 7;         { I am serving -----------------     }
    HAND_PUNCH             = 8;         { !! not used                        }

    { Role constants }
    ROLE_WAIT              = 0;         { just fucking around                }
    ROLE_PRE_SERVICE       = 1;         { before service                     }
    ROLE_PRE_NET_PLAYER    = 2;         { begore playing at the net          }
    ROLE_PRE_RETURN        = 3;         { before returning the service       }
    ROLE_SERVICE           = 4;         { serving                            }
    ROLE_RETURN            = 5;         { waiting for the service            }
    ROLE_NET_PLAYER        = 6;         { playing at the net                 }
    ROLE_BACK_PLAYER       = 7;         { playing back on the field          }

    { Player position constants }
    SIDE_LEFT              = 0;         { The left side                      }
    SIDE_RIGHT             = 1;         { What the hell could this be ?      }

    WHEREBALL_SERVER_HAS        = 0;    { The server has the ball            }
    WHEREBALL_YOU_HIT           = 1;    { We hit the ball -- it is now flying}
                                        { away                               }
    WHEREBALL_ENEMY_HIT         = 2;    { The enemy hit the ball - and it is }
                                        { now our turn to do so              }
    WHEREBALL_YOU_ONCE_DROPED   = 3;    { !! not used                        }
    WHEREBALL_ENEMY_ONCE_DROPED = 4;    { !! not used                        }
    WHEREBALL_OUT_OF_GAME       = 5;    { The ball is not in the game        }
    WHEREBALL_YOU_SERVER_HIT    = 6;    { The ball was served by the opponent}
    WHEREBALL_ENEMY_SERVER_HIT  = 7;    { You served the ball                }

{ Just a rectangle }
type typeRECTANGLE = record
    x1,y1,x2,y2:integer;
end;

{ The returned action from Compute function }
type typeACTION = record
     HandHold:integer;                  { What are you doing with your hands }
                                        { only values HAND_STAND_BY and      }
                                        { HAND_SERVICE make sence            }
     VelocityX:real;                    { X velocity in this step            }
     VelocityY:real;                    { Y velocity in this step            }
     AimX:real;                         { The point I am aiming at when      }
     AimY:real;                         { serving.                           }

     { Comunication variables }
     MessageLong:longint;               { Say a longint                      }
     MessageX:real;                     { Say a real                         }
     MessageY:real;                     { Say a real                         }
     MessageString:string;              { Say a string                       }
end;

{ The score -- this structure when given to a player is transformed so
               that that player is the index 1 team}
type typeSCORE = record
     Points:array[1..2] of integer;
     Games:array[1..2] of integer;
     Sets:array[1..2] of integer;
end;

{ The state of a player in a match }
type typePLAYER_STATE = record
    bFreeWill:BOOLEAN;                  { Did the player decide his own      }
                                        { action                             }
    PlayerNo:integer;                   { Index of the player in the settings}
                                        { structure                          }
    PositionX,PositionY:real;           { Position of the player             }
    VelocityX,VelocityY:real;           { Velocity of the player             }
    HandHold:integer;                   { The hold-of-his-hands              }
    Role:integer;                       { Role of the player                 }
    Position:integer;                   { Position -- LEFT or RIGHT          }

    TimePenaltyPoints:integer;          { The penalty points you've got      }
    LastComputeDuration:real;           { The time your compute function     }
                                        { took the last time                 }

     { Comunication variables }
     MessageLong:longint;               { Sad a longint                      }
     MessageX:real;                     { Sad a real                         }
     MessageY:real;                     { Sad a real                         }
     MessageString:string;              { Sad a string                       }
end;

{ The state of the Match - this structure is transformed when given to a
      player so that the player is the no. 1 in the Players array and all
      postitions and vectors are transformed to place the player in the
      bottom half of the playground.}
type typeMATCH_STATE = record
    MatchTime:real;                     { Time - from the begining of the match}
    PointTime:real;                     { Time - this point                  }
    Score:typeSCORE;                    { score  (!transformed               }
    bTeabreak:BOOLEAN;                  { !! not used                        }
    bSecondService:BOOLEAN;             { !! not used                        }
    bTwoPlayers:BOOLEAN;                { not interesting                    }
    bStopMatch:BOOLEAN;                 { not interesting                    }

    GameRound:integer;                  { counter incremented each time      }
                                        { a point is played                  }
    Event:integer;                      { This steps event                   }
    LastPointTo:integer;                { Who got the last point  0-if noone }
                                        { 1-you 2-opponent                   }
    JudgeSad:integer;                   { The last sentence of the judge     }
    WhereBall:integer;                  { Ball status                        }

    BallX,BallY,BallZ:real;             { Ball position   ( BallZ !! not used}
    BallVX,BallVY,BallVZ:real;          { Ball velocity                      }
    Players:array[1..4] of typePLAYER_STATE; { Array of the 4 players in the }
                                             { game                          }

    {Internal parameters -- do not use they are not transformed              }
    iServer:integer;                    { !! }
    ServerSide:integer;                 { !! }
    strInfo:string;                     { ?? what is this }
    EventWho:integer;                   { Who made the actual event }
end;

type typePLAYER_SETTINGS = record
    strName:string;                 { The players name                       }
    Color:integer;                  { The players color                      }

    MaxSpeed:real;                  { Maximum speed of the player            }
    ServiceSpeed:real;              { Service ball speed                     }
    ReturnSpeed:real;               { Return ball speed                      }
    NeutralSpeed:real;              { Neutral -- waiting speed of the player }
    Radius:real;                    { Radius of the player                   }

    { Ptrs to functions called by the environment                            }
    { !!!!!!!!!!!!!! DO NOT CALL THIS FUNCTION DIRECTLY                      }
    { !!!!!!!!!!!!!! IT IS STRICTLY FORBIDDEN                                }
    FnGetName:function:string;
    FnInitSession:function( iPlayer:integer ):string;
    FnInitMatch:function( var Match:typeMATCH_STATE ):string;
    FnCompute:procedure( var Match:typeMATCH_STATE; var Action:typeACTION);
end;

type typeSETTINGS = record
    GroundX1,GroundY1:real;         { The position of the PlayGround         }
    GroundX2,GroundY2:real;
    ServiceDX,ServiceDY:real;       { The position of the bounderies for     }
                                    { service measured from the side line (x)}
                                    { and from the base line (y)             }
    AlgerianX1,AlgerianY1:real;     { Ackerman's bounderies                  }
    AlgerianX2,AlgerianY2:real;
    AlgerianD:real;                 { Yellow line distance from the net      }
    AlgerianBallSpeed:real;         { Default ball speed                     }
    AlgerianServiceBallSpeed:real;  { Default service ball speed             }
    AlgerianMaxPlayerSpeed:real;    { Default maximum player speed           }
    AlgerianNeutralSpeed:real;      { Default neutral player speed           }
    AlgerianPlayerRadius:real;      { Default player radius                  }
    GroundAxisX:real;               { Computed!! - the playgorund axis X coor}
    NetY:real;                      { Computed!! - net y coordinate          }
    nPlayers:integer;               { Number of players in the tournament    }
    nMatches:integer;               { Number of matches                      }
    nPointsToWinGame:integer;       { Points to win a game                   }
    nGamesToWinSet:integer;         { Games to win a set                     }
    nSetsToWinMatch:integer;        { Sets to win a match                    }
    maxPoints:integer;              { Max Points - if score reaches this     }
                                    { number a player wins also if the       }
                                    { opponent has only one point less       }
    maxGames:integer;               { Max Games                              }
    GameMode:integer;               { Mode: ... TOURNAMENT etc.              }
    DisplayMode:integer;            { 2D, etc.                               }
    bWaitRetrace:BOOLEAN;           { Do we wait for vertical retrace        }
    bDebugOutput:BOOLEAN;           { Display debug output                   }
    MaxPenaltyPoints:integer;       { Max penalty points to be out           }
    MaxComputeDuration:real;        { Maximum duration of compute procedure  }
    bTestTime:BOOLEAN;              { Is the timeout tested ?                }
    bDisplayIdle:BOOLEAN;           { Should the idle line be displayed      }
    bSmoothRedraw:BOOLEAN;          { Redraw in smaller steps                }
    bProcessorTestPlayers:BOOLEAN;  { Use processor-ocupation-test-players   }

    bSound:BOOLEAN;                 { Sound is on                            }
    bGus:BOOLEAN;               {GUS  Play sounds using GUS                  }
    bBeQuite:BOOLEAN;           {GUS  The 'BE QUITE' disaster                }
    TimeToBeQuite:real;         {GUS  The length of the test period for noise}
    MinTimeToRepeatBeQuite:real;{GUS  How often 'BE QUITE' is repeated       }
    MaximumNoise:integer;       {GUS  Maximum noise to accept it as silence  }
    bNoiseTest:BOOLEAN;          {GUS  Display the actual noise in the room   }

    SecWaitBeforeBegin:real;        { Timeout for judge to begin the game    }
    SecDelayBegin:real;             { Some short delay                       }
    SecToServe:real;                { The server has x seconds to serve      }
    maxVtoBegin:real;               { Maximum speed of the players for the   }
                                    { judge to begin the game                }
    SecWaitAfterGame:real;          { the pause after game                   }
    SecWaitAfterSet:real;           { the pause after set                    }
    WaitAfterScored:real;           { after scored pause                     }

    TimeStep:real;                  { The step                               }
    TimeMultiplier:real;            { The REAL-TIME multiplier, -1 for fastest}
    nStepsPerCount:integer;         { Each x steps the count procedures are  }
                                    { initiated                              }
    bIntro:boolean;                 { Play intro }
    bRecordGame:boolean;            { Do we record the gase                  }
    strRecordFile:string;
    strScoreFile:string;

    ScreenRect:typeRECTANGLE;       { The screen size                        }

    { Player definition structures }
    Players:array[1..MAX_PLAYERS] of typePLAYER_SETTINGS;
    { Schedule of the matches      }
    Schedule:array[1..MAX_MATCHES,1..4] of integer;
end;


type typeALL_ACTIONS = array[1..4] of typeACTION;

var
   Settings:typeSETTINGS;

procedure VectInDir( var x,y,size:real );
procedure VectMaxInDir( var x,y,size:real );
function Distance( x1,y1,x2,y2:real ):real;
function GetExactTime:longint;
procedure Wait(ptime:real);


implementation

{ Vector of size SIZE in direction of X,Y}
procedure VectInDir( var x,y,size:real );
var OldSize:real;
begin
     OldSize := sqrt(x*x+y*y);
     x := x/OldSize*size;
     y := y/OldSize*size;
end;

{ Vector of maximum size SIZE in direction of X,Y}
procedure VectMaxInDir( var x,y,size:real );
var OldSize:real;
begin
     OldSize := sqrt(x*x+y*y);
     if OldSize > size then
     begin
        x := x/OldSize*size;
        y := y/OldSize*size;
     end;
end;

{ Distance between two points }
function Distance( x1,y1,x2,y2:real ):real;
begin
   Distance := sqrt((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2))
end;


{ Returns a state of a exact time counter. Counter started when the machine
  was turned on.
}
{ Incremented each 214.5527079 microseconds. That is 4660.859375 a second}
{ EXACT_TIME_STEP = 214.5527079e-6 }
{ EXACT_TIME_CLICKS_PER_SEC = 4660.859375 }
function GetExactTime:longint;
label IsOk;
var lowWord,highWord:WORD;
begin

asm
   push ds
   mov ax,0
   mov ds,ax

   mov bx,[046ch]
   mov dx,[046eh]

   mov al,0
   out 43h,al
   in al,40h
   mov cl,al
   in al,40h
   mov ch,al

   mov ax,[046ch]
   cmp ax,bx
   jz IsOk
   mov bx,ax
   mov dx,[046eh]

   mov al,0
   out 43h,al
   in al,40h
   mov cl,al
   in al,40h
   mov ch,al

IsOk:
   pop ds

{cx
bx
dx}
   neg cx

   mov dh,dl
   mov dl,bh
   mov ah,bl
   mov al,ch

{ ax-dx}

   mov lowWord,ax
   mov highWord,dx

end;

    GetExactTime := highWord*65536 + lowWord;
end;

procedure Wait(ptime:real);
var beginTime:longint;
begin
    beginTime := GetExactTime;
    while (GetExactTime - beginTime) < ptime*EXACT_TIME_CLICKS_PER_SEC do
    begin
        {Idle}
    end;
end;

end.