Unit uMatch;

interface

Uses
    Types,Setting,uSprite,Move,MyGraph,Crt,KbWatch,uSound,ultraWav,Graph;

const
    { What was achieved with the last point -- a POINT, a GAME, a SET or a MATCH}
    MATCH_NOTHING = 0;
    MATCH_GAME = 1;
    MATCH_SET = 2;
    MATCH_MATCH = 3;
    MATCH_POINT = 4;

procedure Match( iActualMatch:integer);
procedure InitMatch( iActualMatch:integer; var Match:typeMATCH_STATE);
function SetScore( var Match:typeMATCH_STATE):integer;
function Fault( var Match:typeMATCH_STATE ):BOOLEAN;
function CheckBegin( var Match:typeMATCH_STATE):BOOLEAN;
procedure BeginPlay( var Match:typeMATCH_STATE);
procedure SetWaitRoles( var Match:typeMATCH_STATE );
procedure SetService( iPlayer,ServiceSide:integer; var Match:typeMATCH_STATE );
procedure StoreScoreBeginMatch( var Match:typeMATCH_STATE );
procedure StoreScoreSet( var Match:typeMATCH_STATE );
procedure StoreScoreMatch( var Match:typeMATCH_STATE );
procedure soundScore( MatchEvent:integer; var Match:typeMATCH_STATE);

implementation

{ Index of bad point for the guy i }
function BadPoint( i:integer ):integer;
begin
    if (i = 1) or (i = 2) then
        BadPoint := 2
    else
        BadPoint := 1;
end;

{ Index of good point for the guy i }
function GoodPoint( i:integer ):integer;
begin
    if (i = 1) or (i = 2) then
        GoodPoint := 1
    else
        GoodPoint := 2;
end;

var LastPlayedBeQuite:longint;
var LastWereNotQuite:longint;

function AreQuite:BOOLEAN;
var Noise:integer;
var strNoise:string;
begin
     if (not Settings.bBeQuite) or (not Settings.bGus) then
     begin
         AreQuite := TRUE;
         exit;
     end;
     if (KbIsPressed(60)) then          { F2 for quitness            }
     begin
        AreQuite := TRUE;
        exit;
     end;

     Noise := getVolume;

     if (Settings.bNoiseTest) then begin
                setcolor(0);
                bar(300,0,330,30);
                setcolor(4);
                str(Noise,strNoise);
                outtextxy(300,0,strNoise);
     end;

     if (Noise > Settings.MaximumNoise) then
     begin
         AreQuite := FALSE;
         LastWereNotQuite := GetExactTime;
         if (GetExactTime - LastPlayedBeQuite)*EXACT_TIME_STEP > Settings.MinTimeToRepeatBeQuite then
         begin
              soundBeQuite;
              LastPlayedBeQuite := GetExactTime;
         end;
     end
     else
     begin
         if (GetExactTime - LastWereNotQuite)*EXACT_TIME_STEP > Settings.TimeToBeQuite then
              AreQuite := TRUE
         else
              AreQuite := FALSE;
     end;
end;

{ The match procedure ... all of it's steps }
procedure Match( iActualMatch:integer);
var
    Match:typeMATCH_STATE;
    TmpMatch:typeMATCH_STATE;
    i:integer;
    WaitCycles:integer;
    MatchEvent:integer;
    SideScored:integer;
    strNames:string;
    bAreQuite:BOOLEAN;
begin
    { Initialize the Match structure }
    InitMatch(iActualMatch,Match);

    DrawWorld(REDRAW_ALL,Match);

    { Write a record into the archive file }
    StoreScoreBeginMatch(Match);

    { Call players InitMatch function }
    for i := 1 to 4 do
    begin
        CopyStateForPlayer(i,Match,TmpMatch);
        Settings.Players[Settings.Schedule[iActualMatch,i]].FnInitMatch(TmpMatch);
    end;

    { Till someone wins }
    while TRUE do begin
        inc(Match.GameRound); { next round    }
        SetService(Match.iServer,Match.ServerSide,Match);
                             { Sets the roles of all players before service }
                             { player x is serving                          }

        for i := 1 to 4 do Match.Players[i].bFreeWill := FALSE;

        { Waiting for players to place themselves }
        WaitCycles := trunc(1/(Settings.TimeStep*Settings.nStepsPerCount)*Settings.SecWaitBeforeBegin);
        i := 1;
        bAreQuite := TRUE;
        LastPlayedBeQuite := GetExactTime;
        while TRUE do
        begin                 { wait for all players to be on their places   }
            if (Settings.bBeQuite) and (i mod 8 = 0) then
                startRecording;
            MoveWorld(Match);
            if (i mod 8 = 0) then
            begin
                bAreQuite := AreQuite;
            end;
            if CheckBegin(Match) and bAreQuite then
                break;
            if (i >= WaitCycles) and bAreQuite then
                break;
            inc(i);
        end;

        { Waiting some short period to begin the game }
        WaitCycles := trunc(1/Settings.TimeStep/Settings.nStepsPerCount*Settings.SecDelayBegin);
        for i := 1 to WaitCycles do
        begin                 { wait 0.5 seconds }
            MoveWorld(Match);
        end;

        BeginPlay(Match);     { begin playing - EVENT_BEGIN_PLAY,            }
                              { change roles                                 }
        SoundBeginPlay;

        Match.strInfo := 'Play !';
        DrawWorld(REDRAW_TURN,Match);

        for i := 1 to 4 do Match.Players[i].bFreeWill := FALSE;

        { While no fault is done -- PLAY}
        while not Fault(Match) do
        begin
            MoveWorld(Match);
        end;
        { a point was scored }

        for i := 1 to 4 do Match.Players[i].bFreeWill := FALSE;


        { Construct the info string -- what happened }
        case Match.JudgeSad of
            JUDGE_NOTHING:      Match.strInfo := '';
            JUDGE_OUT:          Match.strInfo := 'Out';
            JUDGE_LOST:         Match.strInfo := 'Point';
            JUDGE_NET:          Match.strInfo := 'Net';
            JUDGE_SERVICE_OUT:  Match.strInfo := 'Out';
            JUDGE_SERVICE_NET:  Match.strInfo := 'Net';
            JUDGE_SERVICE_FOOT_FAULT:   Match.strInfo := 'Service Foot Fault';
            JUDGE_SERVICE_TIMEOUT:      Match.strInfo := 'Service TimeOut';
            JUDGE_FOOT_FAULT:           Match.strInfo := 'Foot Fault';
        end;
        DrawWorld(REDRAW_TURN,Match);

        { wait }
        WaitCycles := trunc(1/Settings.TimeStep/Settings.nStepsPerCount*Settings.WaitAfterScored);
        for i := 1 to WaitCycles do
        begin                 { wait seconds }
            MoveWorld(Match);
        end;

        { set the score }
        MatchEvent := SetScore(Match);

        soundScore(MatchEvent,Match);

        SetWaitRoles(Match);

        { set info: Game - Korda ... }
        if Match.LastPointTo <> 0 then
        begin
           strNames := Settings.Players[Match.Players[Match.LastPointTo*2-1].PlayerNo].strName + ', '
                       + Settings.Players[Match.Players[Match.LastPointTo*2].PlayerNo].strName;
        end;
        case MatchEvent of
MATCH_POINT: begin
              Match.strInfo := 'Point - ' + strNames;
              DrawWorld(REDRAW_TURN,Match);
            end;
MATCH_GAME: begin
              Match.strInfo := 'Game - ' + strNames;
              DrawWorld(REDRAW_TURN,Match);
              WaitCycles := trunc(1/Settings.TimeStep/Settings.nStepsPerCount*Settings.SecWaitAfterGame);
              for i := 1 to WaitCycles do {Wait 8 seconds}
                 MoveWorld(Match);
            end;
MATCH_SET:begin
              Match.strInfo := 'Set - ' + strNames;
              DrawWorld(REDRAW_TURN,Match);
              WaitCycles := trunc(1/Settings.TimeStep/Settings.nStepsPerCount*Settings.SecWaitAfterSet);
              for i := 1 to WaitCycles do {Wait 8 seconds}
                 MoveWorld(Match);
            end;
MATCH_MATCH:begin
              Match.strInfo := 'Match - ' + strNames;
              DrawWorld(REDRAW_TURN,Match);
              WaitCycles := trunc(1/Settings.TimeStep/Settings.nStepsPerCount*Settings.SecWaitAfterSet);
              for i := 1 to WaitCycles do {Wait 8 seconds}
                 MoveWorld(Match);
              break;
            end;
        end;
    end;

end;

procedure InitMatch( iActualMatch:integer; var Match:typeMATCH_STATE);
var i:integer;
begin
    with Match do begin
        Score.Points[1] := 0;
        Score.Points[2] := 0;
        Score.Games[1] := 0;
        Score.Games[2] := 0;
        Score.Sets[1] := 0;
        Score.Sets[2] := 0;
        MatchTime := 0;
        PointTime := 0;
        bTeabreak := FALSE;
        bSecondService := FALSE;
        bTwoPlayers := FALSE;
        bStopMatch := FALSE;
        iServer := 1;
        ServerSide := SIDE_LEFT;
        GameRound := 0;
        Event := EVENT_NONE;
        LastPointTo := 0;
        JudgeSad := JUDGE_NOTHING;

        BallX := 0;
        BallY := 0;
        BallZ := 0;
        BallVX := 0.1;
        BallVY := 0.1;
        BallVZ := 0.1;

        strInfo := '';
    end;

    for i := 1 to 4 do
    begin
        with Match.Players[i] do begin
            bFreeWill := FALSE;
            PlayerNo := Settings.Schedule[iActualMatch,i];
            PositionX := -1;
            PositionY := (Settings.GroundY1+Settings.GroundY2)/2 + 2*i-3;
            VelocityX := 0;
            VelocityY := 0;
            HandHold := HAND_FOREHAND;
            Role := ROLE_WAIT;
            Position := SIDE_LEFT;
            TimePenaltyPoints := 0;
            LastcomputeDuration := 0;
        end;
    end;
end;

function SetScore( var Match:typeMATCH_STATE):integer;
var i,j,k:integer;
begin
   SetScore := MATCH_NOTHING;

   if Match.LastPointTo <> 0 then
   begin
       SetScore := MATCH_POINT;
       inc(Match.Score.Points[Match.LastPointTo]);
   end;

   if (Match.LastPointTo <> 0) then
   begin
       {Scored a point}
       Match.ServerSide := (Match.ServerSide+1) mod 2;
       for i := 1 to 2 do begin
           if (Match.Score.Points[i] >= Settings.nPointsToWinGame) and
              (((Match.Score.Points[i] - Match.Score.Points[3-i]) >= 2) or
               (Match.Score.Points[i] >= Settings.maxPoints)) then
           begin
               {Won a game}
               case Match.iServer of
                 1: Match.iServer := 3;
                 2: Match.iServer := 4;
                 3: Match.iServer := 2;
                 4: Match.iServer := 1;
               end;
               SetScore := MATCH_GAME;
               Match.Score.Points[1] := 0;
               Match.Score.Points[2] := 0;
               inc(Match.Score.Games[i]);
               for j := 1 to 2 do begin
                   if (Match.Score.Games[j] >= Settings.nGamesToWinSet) and
                      (((Match.Score.Games[j] - Match.Score.Games[3-j]) >= 2) or
                      (Match.Score.Games[j] >= Settings.maxGames)) then
                   begin
                       {Won a set}
                       StoreScoreSet(Match);
                       SetScore := MATCH_SET;
                       Match.Score.Games[1] := 0;
                       Match.Score.Games[2] := 0;
                       inc(Match.Score.Sets[j]);
                       for k := 1 to 2 do begin
                           if (Match.Score.Sets[k] >= Settings.nSetsToWinMatch) then
                           begin
                               StoreScoreMatch(Match);
                               SetScore := MATCH_MATCH;
                           end;
                       end;
                   end;
               end;
           end;
       end;
   end;
   if (Match.bStopMatch) then
       SetScore := MATCH_MATCH;
end;

function Fault( var Match:typeMATCH_STATE ):BOOLEAN;
begin
     Fault := FALSE;
     if (Match.WhereBall = WHEREBALL_SERVER_HAS) and (Match.PointTime > Settings.SecToServe) then
     begin
         {Service timeout}
         with Match do begin
             JudgeSad := JUDGE_SERVICE_TIMEOUT;
             Event := EVENT_SCORED;
             LastPointTo := BadPoint(iServer);
             WhereBall := WHEREBALL_OUT_OF_GAME;
         end;
         Fault := TRUE;
     end;
     if (Match.WhereBall = WHEREBALL_OUT_OF_GAME) then
     begin
         Fault := TRUE;
     end;
end;

function CheckBegin( var Match:typeMATCH_STATE):BOOLEAN;
var i:integer;
var CheckBegi:BOOLEAN;
begin
    CheckBegi := TRUE;
    for i := 1 to 4 do begin
       if abs(Match.Players[i].VelocityX) > Settings.maxVtoBegin then
       begin
          CheckBegi := FALSE;
          break;
       end;
       if abs(Match.Players[i].VelocityY) > Settings.maxVtoBegin then
       begin
          CheckBegi := FALSE;
          break;
       end;
    end;
    if CheckBegi then
       CheckBegin := TRUE
    else
       CheckBegin := FALSE;
end;

procedure BeginPlay( var Match:typeMATCH_STATE);
var i:integer;
begin
     Match.Event := EVENT_BEGIN_PLAY;

     for i := 1 to 4 do begin
         case Match.Players[i].Role of
ROLE_PRE_SERVICE:       Match.Players[i].Role := ROLE_SERVICE;
ROLE_PRE_NET_PLAYER:    Match.Players[i].Role := ROLE_NET_PLAYER;
ROLE_PRE_RETURN:        Match.Players[i].Role := ROLE_RETURN;
ROLE_WAIT:              Match.Players[i].Role := ROLE_WAIT
         else
             HovnoHovnoZlataRybka;
         end;
     end;

     Match.PointTime := 0;
end;

procedure SetWaitRoles( var Match:typeMATCH_STATE );
var i:integer;
begin
   for i := 1 to 4 do
       Match.Players[i].Role := ROLE_WAIT;
end;

procedure SetService( iPlayer,ServiceSide:integer; var Match:typeMATCH_STATE );
var ReturnSide:integer;
begin
     if ServiceSide = SIDE_RIGHT then
         ReturnSide := SIDE_LEFT
     else
         ReturnSide := SIDE_RIGHT;

     case iPlayer of
1:      begin
             Match.Players[1].Role := ROLE_PRE_SERVICE;
             Match.Players[1].Position := ServiceSide;
             Match.Players[2].Role := ROLE_PRE_NET_PLAYER;
             Match.Players[2].Position := ReturnSide;
{             Match.Players[3].Role := ROLE_PRE_RETURN;
             Match.Players[3].Position := ReturnSide;
             Match.Players[4].Role := ROLE_PRE_NET_PLAYER;
             Match.Players[4].Position := ServiceSide;}
             if ServiceSide = SIDE_LEFT then begin
               Match.Players[3].Role := ROLE_PRE_RETURN;
               Match.Players[3].Position := ReturnSide;
               Match.Players[4].Role := ROLE_PRE_NET_PLAYER;
               Match.Players[4].Position := ServiceSide;
             end
             else begin
               Match.Players[3].Role := ROLE_PRE_NET_PLAYER;
               Match.Players[3].Position := ServiceSide;
               Match.Players[4].Role := ROLE_PRE_RETURN;
               Match.Players[4].Position := ReturnSide;
             end;
        end;
2:      begin
             Match.Players[2].Role := ROLE_PRE_SERVICE;
             Match.Players[2].Position := ServiceSide;
             Match.Players[1].Role := ROLE_PRE_NET_PLAYER;
             Match.Players[1].Position := ReturnSide;
{             Match.Players[4].Role := ROLE_PRE_RETURN;
             Match.Players[4].Position := ReturnSide;
             Match.Players[3].Role := ROLE_PRE_NET_PLAYER;
             Match.Players[3].Position := ServiceSide;}
             if ServiceSide = SIDE_LEFT then begin
               Match.Players[4].Role := ROLE_PRE_RETURN;
               Match.Players[4].Position := ReturnSide;
               Match.Players[3].Role := ROLE_PRE_NET_PLAYER;
               Match.Players[3].Position := ServiceSide;
             end
             else begin
               Match.Players[4].Role := ROLE_PRE_NET_PLAYER;
               Match.Players[4].Position := ServiceSide;
               Match.Players[3].Role := ROLE_PRE_RETURN;
               Match.Players[3].Position := ReturnSide;
             end;
        end;
3:      begin
             Match.Players[3].Role := ROLE_PRE_SERVICE;
             Match.Players[3].Position := ServiceSide;
             Match.Players[4].Role := ROLE_PRE_NET_PLAYER;
             Match.Players[4].Position := ReturnSide;
{             Match.Players[1].Role := ROLE_PRE_RETURN;
             Match.Players[1].Position := ReturnSide;
             Match.Players[2].Role := ROLE_PRE_NET_PLAYER;
             Match.Players[2].Position := ServiceSide;}
             if ServiceSide = SIDE_LEFT then begin
               Match.Players[1].Role := ROLE_PRE_RETURN;
               Match.Players[1].Position := ReturnSide;
               Match.Players[2].Role := ROLE_PRE_NET_PLAYER;
               Match.Players[2].Position := ServiceSide;
             end
             else begin
               Match.Players[1].Role := ROLE_PRE_NET_PLAYER;
               Match.Players[1].Position := ServiceSide;
               Match.Players[2].Role := ROLE_PRE_RETURN;
               Match.Players[2].Position := ReturnSide;
             end;
        end;
4:      begin
             Match.Players[4].Role := ROLE_PRE_SERVICE;
             Match.Players[4].Position := ServiceSide;
             Match.Players[3].Role := ROLE_PRE_NET_PLAYER;
             Match.Players[3].Position := ReturnSide;
{             Match.Players[2].Role := ROLE_PRE_RETURN;
             Match.Players[2].Position := ReturnSide;
             Match.Players[1].Role := ROLE_PRE_NET_PLAYER;
             Match.Players[1].Position := ServiceSide;}
             if ServiceSide = SIDE_LEFT then begin
               Match.Players[2].Role := ROLE_PRE_RETURN;
               Match.Players[2].Position := ReturnSide;
               Match.Players[1].Role := ROLE_PRE_NET_PLAYER;
               Match.Players[1].Position := ServiceSide;
             end
             else begin
               Match.Players[2].Role := ROLE_PRE_NET_PLAYER;
               Match.Players[2].Position := ServiceSide;
               Match.Players[1].Role := ROLE_PRE_RETURN;
               Match.Players[1].Position := ReturnSide;
             end;
        end;
     end;

     Match.WhereBall := WHEREBALL_SERVER_HAS;
end;

procedure StoreScoreBeginMatch( var Match:typeMATCH_STATE );
var ArchiveFile:text;
begin
   assign(ArchiveFile,Settings.strScoreFile);
   append(ArchiveFile);

   writeln(ArchiveFile,'');
   writeln(ArchiveFile,'*********************************************');
   writeln(ArchiveFile,'Match -- Team no. 1: ',Match.Players[1].PlayerNo,' ',
                              Settings.Players[Match.Players[1].PlayerNo].strName);
   writeln(ArchiveFile,'                     ',Match.Players[2].PlayerNo,' ',
                                             Settings.Players[Match.Players[2].PlayerNo].strName);
   writeln(ArchiveFile,'         Team no. 2: ',Match.Players[3].PlayerNo,' ',
                                 Settings.Players[Match.Players[3].PlayerNo].strName);
   writeln(ArchiveFile,'                     ',Match.Players[4].PlayerNo,' ',
                                             Settings.Players[Match.Players[4].PlayerNo].strName);
   writeln(ArchiveFile,'');

   close(ArchiveFile);

end;

procedure StoreScoreSet( var Match:typeMATCH_STATE );
var ArchiveFile:text;
begin
   assign(ArchiveFile,Settings.strScoreFile);
   append(ArchiveFile);

   writeln(ArchiveFile,'Set won: ',Match.Score.Games[1],':',Match.Score.Games[2]);

   close(ArchiveFile);
end;

procedure StoreScoreMatch( var Match:typeMATCH_STATE );
var ArchiveFile:text;
begin
   assign(ArchiveFile,Settings.strScoreFile);
   append(ArchiveFile);

   writeln(ArchiveFile,'Match won: ',Match.Score.Sets[1],':',Match.Score.Sets[2]);

   close(ArchiveFile);
end;

{ SOUNDS !!!!!!!!!!!!!1 }

procedure playWaitWav(kanal:byte; wav:wavType; var Match:typeMATCH_STATE);
var WaitCycles:integer;
    i:integer;
begin
    playWav(kanal,wav);
    WaitCycles := trunc(1/(Settings.TimeStep*Settings.nStepsPerCount)*(wav.Dlzka/wav.Frekvencia));
    for i := 1 to WaitCycles do begin
        MoveWorld(Match);
    end;
end;

procedure soundPlayers( var Match:typeMATCH_STATE );
begin
    if Match.LastPointTo = 1 then
    begin
       Wait(0.1);
       playWaitWav(6,wav_player[Match.Players[1].PlayerNo],Match);
       Wait(0.3);
       playWaitWav(6,wav_player[Match.Players[2].PlayerNo],Match);
    end
    else
    begin
       Wait(0.1);
       playWaitWav(6,wav_player[Match.Players[3].PlayerNo],Match);
       Wait(0.3);
       playWaitWav(6,wav_player[Match.Players[4].PlayerNo],Match);
    end;
end;

procedure soundPoints( var Match:typeMATCH_STATE );
var iSideFirst:integer;
begin
    { 0, 15, 30, 40 }
    if (Match.iServer = 1) or (Match.iServer = 2) then
       iSideFirst := 1
    else
       iSideFirst := 2;

    if (Match.Score.Points[1] > 3) or (Match.Score.Points[2] > 3) then
    begin
        if (Match.Score.Points[1] = Match.Score.Points[2]) then
            playWav(6,wav_deuce)
        else
        begin
            playWaitWav(6,wav_advantage,Match);
            soundPlayers(Match);
        end;
        exit;
    end;

    case Match.Score.Points[iSideFirst] of
      0: playWaitWav(6,wav_zero,Match);
      1: playWaitWav(6,wav_one,Match);
      2: playWaitWav(6,wav_two,Match);
      3: playWaitWav(6,wav_three,Match);
    end;

    if (Match.Score.Points[1] = Match.Score.Points[2]) then
    begin
        playWav(6,wav_all);
        exit;
    end;

    case Match.Score.Points[3-iSideFirst] of
      0: playWaitWav(6,wav_zero,Match);
      1: playWaitWav(6,wav_one,Match);
      2: playWaitWav(6,wav_two,Match);
      3: playWaitWav(6,wav_three,Match);
    end;

end;

procedure soundScore( MatchEvent:integer; var Match:typeMATCH_STATE);
begin
  if (not Settings.bSound) or (not Settings.bGus) then
      exit;
  case MatchEvent of
      MATCH_POINT:  soundPoints(Match);
      MATCH_GAME:   begin
        playWaitWav(6, wav_game, Match );
        soundPlayers(Match);
      end;
      MATCH_SET: begin
        playWaitWav(6, wav_game, Match );
        playWaitWav(6, wav_set, Match );
        soundPlayers(Match);
      end;
      MATCH_MATCH: begin
        playWaitWav(6, wav_game, Match );
        playWaitWav(6, wav_set, Match );
        playWaitWav(6, wav_match, Match );
        soundPlayers(Match);
      end;
  end;
end;

begin
     LastPlayedBeQuite := 0;
     LastWereNotQuite := 0;
end.
