unit uSound;

interface

uses crt, GusInit, UltraDrv, UltraWav, Types;

procedure initRecording;
procedure closeRecording;
procedure startRecording;
function getVolume:byte;
procedure soundBeQuite;
procedure soundBeginPlay;
procedure soundEvent( Event,EventWho,Judge:integer );


const SIZE_BUF = 512;
      FREQ = 11025;


var i:byte;
    Buffer:pointer;

    hlasitost:word;

    hrame:boolean;

   wav_begin_play   :wavType;
   wav_quite_please :wavType;
   wav_hit          :wavType;
   wav_hit2         :wavType;
   wav_hit3         :wavType;
   wav_out          :wavType;
   wav_net          :wavType;
   wav_foot_fault   :wavType;
   wav_service_foot_fault    :wavType;
   wav_service_timeout      :wavType;

   wav_player:array[1..MAX_PLAYERS] of wavType;
   wav_deuce:wavType;
   wav_advantage:wavType;
   wav_zero:wavType;
   wav_one:wavType;
   wav_two:wavType;
   wav_three:wavType;
   wav_all:wavType;

   wav_game:wavType;
   wav_set:wavType;
   wav_match:wavType;

    c:char;

implementation

procedure Beep;
begin
   sound(1000);
   delay(50);
   nosound;
end;

procedure BeepShort;
begin
   sound(500);
   delay(10);
   nosound;
end;

procedure initRecording;
begin
   if (not Settings.bGus) then
      exit;
   initGUS;
   UltraDisableLineIn;

   GetMem(Buffer, SIZE_BUF);

   if (Buffer = nil) then begin
        writeln('Cannot allocate memory');
        Halt;
   end;

   loadWav( 'play.wav', wav_begin_play);
   loadWav( 'quite.wav', wav_quite_please );
   loadWav( 'hit.wav',wav_hit);
   loadWav( 'hit2.wav',wav_hit2);
   loadWav( 'hit3.wav',wav_hit3);
   loadWav( 'out.wav',wav_out);
   loadWav( 'net.wav',wav_net);
   loadWav( 'ffault.wav',wav_foot_fault);
   wav_service_foot_fault := wav_foot_fault;
   loadWav( 'toserv.wav',wav_service_timeout);

   loadWav( 'player1.wav',wav_player[1] );
   loadWav( 'player2.wav',wav_player[2] );
   loadWav( 'player3.wav',wav_player[3] );
   loadWav( 'player4.wav',wav_player[4] );
   loadWav( 'player5.wav',wav_player[5] );

   loadWav( 'deuce.wav',wav_deuce );
   loadWav( 'advant.wav',wav_advantage );
   loadWav( 'zero.wav',wav_zero );
   loadWav( 'one.wav',wav_one );
   loadWav( 'two.wav',wav_two );
   loadWav( 'three.wav',wav_three );
   loadWav( 'all.wav', wav_all );

   loadWav( 'game.wav',wav_game );
   loadWav( 'set.wav',wav_set );
   loadWav( 'match.wav',wav_match );
end;

procedure closeRecording;
begin
   if (not Settings.bGus) then
       exit;
   freeWav(wav_begin_play);
   freeWav(wav_quite_please);
   freeWav(wav_hit);
   freeWav(wav_hit2);
   freeWav(wav_hit3);
   freeWav(wav_out);
   freeWav(wav_net);
   freeWav(wav_foot_fault);
   freeWav(wav_service_foot_fault);
   freeWav(wav_service_timeout);
   FreeMem( Buffer, SIZE_BUF );
end;

procedure startRecording;
begin
   if (not Settings.bGus) then
       exit;
   UltraEnableMicIn;
   UltraSetRecordFrequency(FREQ);
   if (UltraPrimeRecord(Buffer, SIZE_BUF, false)) then
   begin {podarilo sa...}                {^- true = ze to bude opakovat!}
         if (UltraGoRecord(0)) then begin
         end else begin
            writeln('Nepodarilo sa startnut Record');
         end;

   end else begin
      writeln('Nepodarilo sa pripravit DMA');
   end;
end;

function getVolume:byte;
var pToByte:^byte;
    i:word;
    hodnota:integer;
    sucet:longint;
    vysledok:integer;
begin
   if (not Settings.bGus) then
   begin
       getVolume := 3;
       exit;
   end;

   UltraWaitRecordDMA;
   UltraDisableMicIn;

   vysledok := 0; sucet := 0;
   pToByte := Buffer;
   for i:=1 to SIZE_BUF do begin
      hodnota := pToByte^; inc(pToByte);
      hodnota := abs(hodnota);
{      if (hodnota >= 10) then}
      inc( sucet, hodnota );
   end;
   vysledok := sucet div SIZE_BUF;
   getVolume := vysledok;
end;


procedure soundBeQuite;
begin
    if (not Settings.bGus) or (not Settings.bSound) then
        exit;
    playWav( 10, wav_quite_please );
end;

procedure soundBeginPlay;
begin
    if (not Settings.bSound) then
       exit;
    if (Settings.bGus) then
        playWav( 9, wav_begin_play )
    else
        Beep;
end;

procedure soundEvent( Event,EventWho,Judge:integer );
begin
    if (not Settings.bSound) then
        exit;
    if (Event = EVENT_HIT_BALL) then
    begin
        if (Settings.bGus) then
        begin
            case random(3) of
            0: playWav( 8, wav_hit  );
            1: playWav( 8, wav_hit2 );
            2: playWav( 8, wav_hit3 );
            end;
        end
        else
            BeepShort;
    end;
    if (Event = EVENT_SCORED) then
    begin
        if (Settings.bGus) then
        begin
           case Judge of
              JUDGE_OUT:   playWav( 7, wav_out );
              JUDGE_NET:   playWav( 7, wav_net );
              JUDGE_SERVICE_FOOT_FAULT: playWav( 7, wav_service_foot_fault );
              JUDGE_SERVICE_TIMEOUT: playWav( 7, wav_service_timeout );
              JUDGE_FOOT_FAULT: playWav( 7, wav_foot_fault );
           end;
        end
        else
            Beep;
    end;
end;


begin {main}
(*
   initRecording;

   loadWav( 'wav1.wav', wav[1] );
   loadWav( 'wav2.wav', wav[2] );
   loadWav( 'wav3.wav', wav[3] );
   loadWav( 'wav4.wav', wav[4] );
   loadWav( 'wav5.wav', wav[8] );
   loadWav( 'wav6.wav', wav[6] );
   loadWav( 'wav7.wav', wav[7] );
   loadWav( 'wav8.wav', wav[5] );
   loadWav( 'wav9.wav', wav[9] );

   hrame := false;
   c := '0';
   repeat
      startRecording;
      {tu mozes chvilu robit cokolvek}
      hlasitost := getVolume;
      writeln( hlasitost );
      if (hlasitost > 1) then
      begin
         if (not hrame) then
         begin
{            playWav( 10, quite_please );
            hrame := true;}
         end;
      end else hrame := false;
      if keypressed then begin
         c := readkey;
         case c of
         '1'..'9': begin playWav( ord(c)-48, wav[ord(c)-48] );
            writeln( 'wav',c );
            end;
         end;
      end;
   until (c = chr(27));

   closeRecording;
   writeln;

   for hlasitost:=1 to wavov do freeWav( wav[hlasitost] );
  *)
end. {main}
